/* ===============================================
  OPEN CLOSE Menu
============================================= */

function diy_tutorials_open_menu() {
  jQuery('button.menu-toggle').addClass('close-panal');
  setTimeout(function(){
    jQuery('nav#main-menu').show();
  }, 100);

  return false;
}

jQuery( "button.menu-toggle").on("click", diy_tutorials_open_menu);

function diy_tutorials_close_menu() {
  jQuery('button.close-menu').removeClass('close-panal');
  jQuery('nav#main-menu').hide();
}

jQuery( "button.close-menu").on("click", diy_tutorials_close_menu);

/* ===============================================
  TRAP TAB FOCUS ON MODAL MENU
============================================= */

  jQuery('button.close-menu').on('keydown', function (e) {
    if (jQuery("this:focus") && (e.which === 9)) {
      e.preventDefault();
      jQuery(this).blur();
      jQuery('#main-menu ul:first li:first a').focus();
    }
  });

  jQuery('button.close-menu').on('keydown', function (event) {
    if (event.shiftKey && event.keyCode == 9) {
      event.preventDefault();
      jQuery(this).blur();
      jQuery('#main-menu ul:last li:last a').focus()
    }
  })

  jQuery('#main-menu ul:first li:first a').on('keydown', function (event) {
    if (event.shiftKey && event.keyCode == 9) {
      event.preventDefault();
      jQuery(this).blur();
      jQuery('button.close-menu').focus()
    }
  })
  
  jQuery(document).ready(function() {
    window.addEventListener('load', (event) => {
        jQuery(".loader").delay(2000).fadeOut("slow");
      });
    })
  /* ===============================================
    Scroll Top //
  ============================================= */
  
  jQuery(window).scroll(function () {
    if (jQuery(this).scrollTop() > 100) {
      jQuery('.scroll-up').fadeIn();
    } else {
      jQuery('.scroll-up').fadeOut();
    }
  });
  
  jQuery('a[href="#tobottom"]').click(function () {
    jQuery('html, body').animate({scrollTop: 0}, 'slow');
    return false;
  });
  (function( $ ) {
  $(window).scroll(function(){
      var sticky = $('.sticky-header'),
      scroll = $(window).scrollTop();

      if (scroll >= 100) sticky.addClass('fixed-header');
      else sticky.removeClass('fixed-header');
    });
  })( jQuery );
   /* ===============================================
  Custom Cursor
============================================= */

const diy_tutorials_customCursor = {
  init: function () {
    this.diy_tutorials_customCursor();
  },
  isVariableDefined: function (el) {
    return typeof el !== "undefined" && el !== null;
  },
  select: function (selectors) {
    return document.querySelector(selectors);
  },
  selectAll: function (selectors) {
    return document.querySelectorAll(selectors);
  },
  diy_tutorials_customCursor: function () {
    const diy_tutorials_cursorDot = this.select(".cursor-point");
    const diy_tutorials_cursorOutline = this.select(".cursor-point-outline");
    if (this.isVariableDefined(diy_tutorials_cursorDot) && this.isVariableDefined(diy_tutorials_cursorOutline)) {
      const cursor = {
        delay: 8,
        _x: 0,
        _y: 0,
        endX: window.innerWidth / 2,
        endY: window.innerHeight / 2,
        cursorVisible: true,
        cursorEnlarged: false,
        $dot: diy_tutorials_cursorDot,
        $outline: diy_tutorials_cursorOutline,

        init: function () {
          this.dotSize = this.$dot.offsetWidth;
          this.outlineSize = this.$outline.offsetWidth;
          this.setupEventListeners();
          this.animateDotOutline();
        },

        updateCursor: function (e) {
          this.cursorVisible = true;
          this.toggleCursorVisibility();
          this.endX = e.clientX;
          this.endY = e.clientY;
          this.$dot.style.top = `${this.endY}px`;
          this.$dot.style.left = `${this.endX}px`;
        },

        setupEventListeners: function () {
          window.addEventListener("load", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          diy_tutorials_customCursor.selectAll("a, button").forEach((el) => {
            el.addEventListener("mouseover", () => {
              this.cursorEnlarged = true;
              this.toggleCursorSize();
            });
            el.addEventListener("mouseout", () => {
              this.cursorEnlarged = false;
              this.toggleCursorSize();
            });
          });

          document.addEventListener("mousedown", () => {
            this.cursorEnlarged = true;
            this.toggleCursorSize();
          });
          document.addEventListener("mouseup", () => {
            this.cursorEnlarged = false;
            this.toggleCursorSize();
          });

          document.addEventListener("mousemove", (e) => {
            this.updateCursor(e);
          });

          document.addEventListener("mouseenter", () => {
            this.cursorVisible = true;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          });

          document.addEventListener("mouseleave", () => {
            this.cursorVisible = false;
            this.toggleCursorVisibility();
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          });
        },

        animateDotOutline: function () {
          this._x += (this.endX - this._x) / this.delay;
          this._y += (this.endY - this._y) / this.delay;
          this.$outline.style.top = `${this._y}px`;
          this.$outline.style.left = `${this._x}px`;

          requestAnimationFrame(this.animateDotOutline.bind(this));
        },

        toggleCursorSize: function () {
          if (this.cursorEnlarged) {
            this.$dot.style.transform = "translate(-50%, -50%) scale(0.75)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1.6)";
          } else {
            this.$dot.style.transform = "translate(-50%, -50%) scale(1)";
            this.$outline.style.transform = "translate(-50%, -50%) scale(1)";
          }
        },

        toggleCursorVisibility: function () {
          if (this.cursorVisible) {
            this.$dot.style.opacity = 1;
            this.$outline.style.opacity = 1;
          } else {
            this.$dot.style.opacity = 0;
            this.$outline.style.opacity = 0;
          }
        },
      };
      cursor.init();
    }
  },
};
diy_tutorials_customCursor.init(); 

/* ===============================================
  Progress Bar
============================================= */
const diy_tutorials_progressBar = {
  init: function () {
      let diy_tutorials_progressBarDiv = document.getElementById("elemento-progress-bar");

      if (diy_tutorials_progressBarDiv) {
          let diy_tutorials_body = document.body;
          let diy_tutorials_rootElement = document.documentElement;

          window.addEventListener("scroll", function (event) {
              let diy_tutorials_winScroll = diy_tutorials_body.scrollTop || diy_tutorials_rootElement.scrollTop;
              let diy_tutorials_height =
              diy_tutorials_rootElement.scrollHeight - diy_tutorials_rootElement.clientHeight;
              let diy_tutorials_scrolled = (diy_tutorials_winScroll / diy_tutorials_height) * 100;
              diy_tutorials_progressBarDiv.style.width = diy_tutorials_scrolled + "%";
          });
      }
  },
};
diy_tutorials_progressBar.init();

/* ===============================================
   sticky copyright
============================================= */

window.addEventListener('scroll', function() {
  var diy_tutorials_footer = document.querySelector('.sticky-copyright');
  if (!diy_tutorials_footer) return; 

  var diy_tutorials_scrollTop = window.scrollY || document.documentElement.diy_tutorials_scrollTop;

  if (diy_tutorials_scrollTop >= 100) {
    diy_tutorials_footer.classList.add('active-sticky');
  }
});

/* ===============================================
   sticky sidebar
============================================= */

window.addEventListener('scroll', function () {
  var diy_tutorials_sidebar = document.querySelector('.sidebar-sticky');
  if (!diy_tutorials_sidebar) return;

  var diy_tutorials_scrollTop = window.scrollY || document.documentElement.scrollTop;
  var diy_tutorials_windowHeight = window.innerHeight;
  var diy_tutorials_documentHeight = document.documentElement.scrollHeight;

  var diy_tutorials_isBottom = diy_tutorials_scrollTop + diy_tutorials_windowHeight >= diy_tutorials_documentHeight - 100;

  if (diy_tutorials_scrollTop >= 100 && !diy_tutorials_isBottom) {
    diy_tutorials_sidebar.classList.add('sidebar-fixed');
  } else {
    diy_tutorials_sidebar.classList.remove('sidebar-fixed');
  }
});
